/// \file main.c VSOS3 Audio Device Driver with input/output (AUDIO.DL3)
/// \author Henrik Herranen, VLSI Solution Oy
// For further instructions on how to use the audio driver can be found
// in the VS1005 VSOS Programmer's Guide, available at
// http://www.vlsi.fi/en/support/software/vside.html

/* For free support for VSIDE, please visit www.vsdsp-forum.com */

// Starting point template for creating VSOS3 libraries and device drivers.
// This will create a <projectname>.DL3 file, which you can copy to 
// your VS1005 Developer Board's system disk's SYS subdirectory.

// DL3 files require VSOS3 kernel version 0.3x to run.


// If you add the libary name to S:CONFIG.TXT, and put the library 
// to S:SYS, it will be loaded and run during boot-up. 

#include <vo_stdio.h>
#include <volink.h>     // Linker directives like DLLENTRY
#include <apploader.h>  // RunLibraryFunction etc
#include <string.h>
#include <mutex.h>
#include <kernel.h>
#include <aucommon.h>
#include <stdlib.h>
#include <speedshift.h>
#include <sysmemory.h>
#include "miscAsm.h"

#if 0
u_int16 audioMutex;
#endif
FILE *audio_orig = NULL;
extern SIMPLE_FILE audioFile;

//void (*RomStart)(void) = (void (*)(void)) 0x8000;

DLLENTRY(init)
ioresult init(char *parameters) {
#if 0
  static s_int16 vector[] = {0, 2345, 500, 2345, 1000, 2345, 3000, 0,
			     -2000, -2000, -2000, -2000, -2000, -2000, -2000, -2000};
  int i;
  s_int16 mem[2] = {0};

  printf("mem %6d %6d\n", mem[0], mem[1]);
  for (i=0; i<16; i++) {
    printf("%6d ", vector[i]);
  }
  printf("\n");

  LimitSlew(vector+0, mem+0, 1000, 8);

  printf("mem %6d %6d\n", mem[0], mem[1]);
  for (i=0; i<16; i++) {
    printf("%6d ", vector[i]);
  }
  printf("\n");

  LimitSlew(vector+1, mem+1, 1000, 8);
  printf("mem %6d %6d\n", mem[0], mem[1]);
  for (i=0; i<16; i++) {
    printf("%6d ", vector[i]);
  }
  printf("\n");
#endif
  
#if defined(USE_STDAUDIOOUT)
  audio_orig = stdaudioout;
  stdaudioout = &audioFile;
#elif defined(USE_STDAUDIOIN)
  audio_orig = stdaudioin;
  stdaudioin = &audioFile;
#endif
  audioFile.Identify = audio_orig->Identify;
  audioFile.op->Ioctl = audio_orig->op->Ioctl;

  return S_OK;
}


DLLENTRY(fini)
void fini(void) {
  // Add code here to force release of resources such as 
  // memory allocated with malloc, entry points, 
  // hardware locks or interrupt handler vectors.
#if defined(USE_STDAUDIOOUT)
    stdaudioout = audio_orig;
#elif defined(USE_STDAUDIOIN)
    stdaudioin = audio_orig;
#endif
}
